//+------------------------------------------------------------------+
//|                                                       Thirds.mq4 |
//|                                                      Magnumfreak |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Magnumfreak"
#property link      ""

#property indicator_chart_window
//int count =1;

extern string usage = "BarCount, 0 mean AUTO";
extern int BarCount = 0;
extern bool alertsMessageBox = true;
extern bool alertsEmail = false;
extern bool alertsSound = true;
extern string alertsSoundFile = "alert.wav";  //enterSoundFile
extern bool showComment = false;

double OnePips;			// const double OnePips = MathPow(10, Digits);
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	OnePips = MathPow(10, Digits);	// const double OnePips = MathPow(10, Digits);

	if (BarCount == 0)
	{
		//Set up the BarCount. H1 TF first. Default barcount set at 170
		//From scoobs
		//BarCount = NormalizeDouble((iATR(NULL, 1440 , 200, 0)/MarketInfo(Symbol(), MODE_POINT))/10, 0);

		
		if (StringSubstr(Symbol(), 0, 6) == "AUDCAD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "AUDCHF") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "AUDJPY") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "AUDNZD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "AUDSGD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "AUDUSD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "CADCHF") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "CADJPY") { BarCount = 180; }
		if (StringSubstr(Symbol(), 0, 6) == "CHFJPY") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "CHFSGD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "EURAUD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "EURCAD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "EURCHF") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "EURGBP") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "EURJPY") { BarCount = 180; }
		if (StringSubstr(Symbol(), 0, 6) == "EURNZD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "EURSGD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "EURUSD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "GBPAUD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "GBPCAD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "GBPCHF") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "GBPJPY") { BarCount = 180; }
		if (StringSubstr(Symbol(), 0, 6) == "GBPUSD") { BarCount = 155; }
		if (StringSubstr(Symbol(), 0, 6) == "NZDCAD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "NZDCHF") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "NZDJPY") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "NZDUSD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "SGDJPY") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "USDCAD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "USDCHF") { BarCount = 180; }
		if (StringSubstr(Symbol(), 0, 6) == "USDHKD") { BarCount = 170; }
		if (StringSubstr(Symbol(), 0, 6) == "USDJPY") { BarCount = 180; }
		if (StringSubstr(Symbol(), 0, 6) == "USDSGD") { BarCount = 170; }
		
		
		//Now accommodate different time frames
		double multiplier;
		if (Period() == PERIOD_M1 ) multiplier = 60;
		if (Period() == PERIOD_M5 ) multiplier = 12;
		if (Period() == PERIOD_M15) multiplier = 4;
		if (Period() == PERIOD_M30) multiplier = 2;
		if (Period() == PERIOD_H1 ) multiplier = 1;
		if (Period() == PERIOD_H4 ) multiplier = 0.25;
		if (Period() == PERIOD_D1 ) multiplier = 0.25 / 6;
	
		double dBarCount = BarCount;
		dBarCount*= multiplier;
		BarCount = dBarCount;
	
	 }//if (BarCount == 0)
		
//---- Object
	ObjectCreate("topline", 1, 0, TimeCurrent(), High[BarCount]);
	ObjectSet("topline", OBJPROP_COLOR, Magenta);
	ObjectSet("topline", OBJPROP_STYLE, STYLE_SOLID);
	ObjectSet("topline", OBJPROP_WIDTH, 2);     

	ObjectCreate("halfbottomline", 1, 0, TimeCurrent(), Low[BarCount]);
	ObjectSet("halfbottomline", OBJPROP_COLOR, Magenta);
	ObjectSet("halfbottomline", OBJPROP_STYLE, STYLE_DASH);
	ObjectSet("halfbottomline", OBJPROP_WIDTH, 1);     

	ObjectCreate("halftopline", 1, 0, TimeCurrent(), High[BarCount]);
	ObjectSet("halftopline", OBJPROP_COLOR, Magenta);
	ObjectSet("halftopline", OBJPROP_STYLE, STYLE_DASH);
	ObjectSet("halftopline", OBJPROP_WIDTH, 1);     

	ObjectCreate("bottomline", 1, 0, TimeCurrent(), Low[BarCount]);
	ObjectSet("bottomline", OBJPROP_COLOR, Magenta);
	ObjectSet("bottomline", OBJPROP_STYLE, STYLE_SOLID);
	ObjectSet("bottomline", OBJPROP_WIDTH, 2);     

	ObjectCreate("onesixth", 1, 0, TimeCurrent(), High[BarCount]);
	ObjectSet("onesixth", OBJPROP_COLOR, Gold);
	ObjectSet("onesixth", OBJPROP_STYLE, STYLE_SOLID);
	ObjectSet("onesixth", OBJPROP_WIDTH, 2);     

	ObjectCreate("twosixth", 1, 0, TimeCurrent(), High[BarCount]);
	ObjectSet("twosixth", OBJPROP_COLOR, Green);
	ObjectSet("twosixth", OBJPROP_STYLE, STYLE_SOLID);
	ObjectSet("twosixth", OBJPROP_WIDTH, 2);    

	ObjectCreate("threesixth", 1, 0, TimeCurrent(), High[BarCount]);
	ObjectSet("threesixth", OBJPROP_COLOR, White);
	ObjectSet("threesixth", OBJPROP_STYLE, STYLE_SOLID);
	ObjectSet("threesixth", OBJPROP_WIDTH, 2);
	
	ObjectCreate("foursixth", 1, 0, TimeCurrent(), Low[BarCount]);
	ObjectSet("foursixth", OBJPROP_COLOR, Green);
	ObjectSet("foursixth", OBJPROP_STYLE, STYLE_SOLID);
	ObjectSet("foursixth", OBJPROP_WIDTH, 2);

	ObjectCreate("fivesixth", 1, 0, TimeCurrent(), Low[BarCount]);
	ObjectSet("fivesixth", OBJPROP_COLOR, Gold);
	ObjectSet("fivesixth", OBJPROP_STYLE, STYLE_SOLID);
	ObjectSet("fivesixth", OBJPROP_WIDTH, 2);

//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
	Comment("");
	ObjectDelete("topline");
	ObjectDelete("halfbottomline");
	ObjectDelete("halftopline");
	ObjectDelete("bottomline");
	ObjectDelete("onesixth");
	ObjectDelete("twosixth");
	ObjectDelete("threesixth");
	ObjectDelete("foursixth");
	ObjectDelete("fivesixth");
//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//----
	static datetime previousTime = 0;

	static int Hpos = 0.0;
	static int Lpos = 0.0;
	static double Hvalue = 0.0;
	static double Lvalue = 0.0;

	static double value = 0.0;		//value top of the chart - value bottom
	static double sixth = 0.0;
	static double seventh = 0.0;

//----
	if(ObjectFind("fivesixth")==-1) {						// object deleted by manual ?
		init();												// Create Object again
		MoveObject(High[BarCount], Low[BarCount], 0.0);		// force re-drow
		previousTime = 0;									// force re-calculate
	}

	if (previousTime != Time[0]) {	
		previousTime = Time[0];
		Hpos    = iHighest(NULL, 0, MODE_HIGH, BarCount, 1);
		Lpos    = iLowest( NULL, 0, MODE_LOW , BarCount, 1);
		Hvalue  = High[Hpos];
		Lvalue  = Low[Lpos];
		value   = Hvalue - Lvalue;
		sixth   = value/6.0;
		seventh = value/7.0;
		MoveObject(Hvalue, Lvalue, sixth);
	}

	if(showComment) { ShowComment(value, sixth, seventh); }
	CheckAlert(Lvalue + sixth, Lvalue + sixth*5.0);

//----
	return(0);
}

//+------------------------------------------------------------------+
//	Show Comment
//+------------------------------------------------------------------+
void ShowComment(double value, double sixth, double seventh)
{
	static datetime previousClose = 0.0;

	if (previousClose != Close[0]) {
		int valueS   = value   * OnePips;
		int sixthS   = sixth   * OnePips;
		int seventhS = seventh * OnePips;
		Comment("Top to bottem          = ", valueS  , " pips", "\n" , 
				"Distance between lines = ", sixthS  , " pips", "\n" , 
				"TAKE PROFIT DISTANCE   = ", seventhS, " pips"
		);
		previousClose = Close[0];
	}
}

//+------------------------------------------------------------------+
//	Move Object
//+------------------------------------------------------------------+
void MoveObject(double Hvalue, double Lvalue, double sixth)
{
	static double OldHvalue = 0.0;
	static double OldLvalue = 0.0;

	if( (OldHvalue != Hvalue) || (OldLvalue != Lvalue) ) {
		datetime NewTime = TimeCurrent();
		ObjectMove("bottomline"		, 0, NewTime, Lvalue);
		ObjectMove("halfbottomline"	, 0, NewTime, Lvalue + sixth*0.5);
		ObjectMove("onesixth"		, 0, NewTime, Lvalue + sixth    );
		ObjectMove("twosixth"		, 0, NewTime, Lvalue + sixth*2.0);
		ObjectMove("threesixth"		, 0, NewTime, Lvalue + sixth*3.0);
		ObjectMove("foursixth"		, 0, NewTime, Lvalue + sixth*4.0);
		ObjectMove("fivesixth"		, 0, NewTime, Lvalue + sixth*5.0);
		ObjectMove("halftopline"	, 0, NewTime, Lvalue + sixth*5.5);
		ObjectMove("topline"		, 0, NewTime, Hvalue);
		OldHvalue = Hvalue;
		OldLvalue = Lvalue;
	}
}

//+------------------------------------------------------------------+
//	Check Alert
//+------------------------------------------------------------------+
void CheckAlert(double onesixth, double fivesixth)
{
//	double OldClose = Close[1];
	double NewClose = Close[0];
	if(NewClose < onesixth)  { doAlert("BUY" ); }
	if(NewClose > fivesixth) { doAlert("SELL"); }
}

//+------------------------------------------------------------------+
//	do Alert
//+------------------------------------------------------------------+
void doAlert(string doWhat)
{
	static string   previousAlert="nothing";
	static datetime previousTime;
	string message;

	if (alertsMessageBox || alertsEmail || alertsSound) {
//		if (previousAlert != doWhat) {
		if (previousAlert != doWhat || previousTime != Time[0]) {
			if (previousAlert == doWhat && previousTime == Time[1]) {
				previousTime = Time[0];
			}
			else {
				previousAlert  = doWhat;
				previousTime = Time[0];
				message =  StringConcatenate(Symbol(), " ", TimeFrameToStr( Period()), " at ", Close[0], " SIXTHS:break signal ", doWhat);
				if (alertsMessageBox)  Alert(message);
				if (alertsEmail)       SendMail(StringConcatenate(Symbol(), " ", doWhat), message);
				if (alertsSound)       PlaySound(alertsSoundFile);
			}
		}
	}
}
//+------------------------------------------------------------------+
//	TimeFrame To Str
//+------------------------------------------------------------------+
string TimeFrameToStr(int timeFrame)
{
	switch (timeFrame) {
	case 1:     return("M1");
	case 5:     return("M5");
	case 15:    return("M15");
	case 30:    return("M30");
	case 60:    return("H1");
	case 240:   return("H4");
	case 1440:  return("D1");
	case 10080: return("W1");
	case 43200: return("MN");
	}

	return("??");
}
//+------------------------------------------------------------------+
